classification
Title: Add parsing support for more types in xmlrpc
Type: enhancement Stage: resolved
Components: Library (Lib) Versions: Python 3.6
process
Status: closed Resolution: fixed
Dependencies: 26873 Superseder:
Assigned To: serhiy.storchaka Nosy List: loewis, python-dev, serhiy.storchaka, terry.reedy
Priority: normal Keywords: patch

Created on 2016-04-29 15:33 by serhiy.storchaka, last changed 2016-09-13 06:30 by serhiy.storchaka. This issue is now closed.

Files
File name Uploaded Description Edit
xmlrpc_extensions.patch serhiy.storchaka, 2016-04-29 15:33 review
xmlrpc_extensions2.patch serhiy.storchaka, 2016-05-07 07:17 review
Messages (5)
msg264504 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2016-04-29 15:33
Apache XML-RPC server supports additional data types (http://ws.apache.org/xmlrpc/types.html). Proposed patch adds support of parsing some of these types: "ex:nil", "ex:i1", "ex:i2", "ex:i8", "ex:biginteger", "ex:float", "ex:bigdecimal". "nil" and "i8" without a prefix was already supported, but the support of "i8" was not documented.

The support of "ex:dateTime" can be added after resolving issue15873.
msg265045 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2016-05-07 07:17
Updated documentation.

Terry, could you please look at the documentation. Is it good English or needed a correction?
msg267053 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2016-06-03 06:17
Table: I believe the format is that the second column describes Pyhton objects that can be marshalled into xml for the rpc.  Sometimes a note is added about the 'return' type, which I presume is the Python object unmarshalled from xml.  From this standpoint,
":class:`int` in range from -2147483648 to 2147483647."
is correct, as well as clearer than the replacement.

I presume 'tags' are in the xml.  "Tag' is meaningless for the returned Python objects.  To me "Values get the ``<int>`` tag." is more grammatical and at least as clear.

---
+The module now supports unmarshalling additional data types used by
+Apache XML-RPC implementation for numerics and ``None``.

The following is clearer to me, although I am puzzled as the table entry for 'nil' in unchanged.

+The module now supports unmarshalling ``None`` and additional data
+types used by Apache XML-RPC implementation for numerics.
msg269700 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2016-07-01 22:00
Thank you for your review Terry.

You can pass an integer in range from -2147483648 to 2147483647, and it is marshalled using the <int> tag. But when you receive tags <i1>, <i2>, etc, they are unmarshalled to integer values, and these values can be out of range from -2147483648 to 2147483647. How to document all these detail in short?

The same is with other types. xmlrpclib is more conservative with data that it sends than with data that it receives. float is marshalled using the <double> flag, but the <float> tag is unmarshalled to float too. None and datetime can be marshalled only if corresponding option is enabled, but always can be unmarshalled. Decimal can't be marshalled, but can be unmarshalled.

For now unmarshalling None is supported from the <nil> tag (this is unofficial extension). But Apache XML-RPC server produces tags with namespace: <ex:nil>, which is not supported in xmplrpclib. The patch adds the support of tags with namespaces, and therefore adds the support of unmarshalling None in Apache XML-RPC server format.
msg275745 - (view) Author: Roundup Robot (python-dev) Date: 2016-09-11 08:24
New changeset ef63e1c999bd by Serhiy Storchaka in branch 'default':
Issue #26885: xmlrpc now supports unmarshalling additional data types used
https://hg.python.org/cpython/rev/ef63e1c999bd
History
Date User Action Args
2016-09-13 06:30:07serhiy.storchakasetstatus: open -> closed
resolution: fixed
stage: patch review -> resolved
2016-09-11 08:24:06python-devsetnosy: + python-dev
messages: + msg275745
2016-09-10 18:37:14serhiy.storchakasetassignee: serhiy.storchaka
2016-07-01 22:00:50serhiy.storchakasetmessages: + msg269700
2016-06-03 06:17:26terry.reedysetmessages: + msg267053
2016-05-07 07:17:36serhiy.storchakasetfiles: + xmlrpc_extensions2.patch
nosy: + terry.reedy
messages: + msg265045

2016-04-29 15:33:20serhiy.storchakasetdependencies: + xmlrpclib raises when trying to convert an int to string when unicode is available
2016-04-29 15:33:03serhiy.storchakacreate